'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _omit = require('lodash/object/omit.js');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputSelect = function (_React$Component) {
  _inherits(InputSelect, _React$Component);

  function InputSelect(props) {
    _classCallCheck(this, InputSelect);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(InputSelect).call(this, props));

    _this.state = {
      value: props.value || ''
    };
    return _this;
  }

  _createClass(InputSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.value
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.timeout) {
        clearTimeout(this.timeout);
      }
      this.timeout = null;
    }
  }, {
    key: 'handlePress',
    value: function handlePress(e) {
      if (e.key === 'Enter') {
        if (this.timeout) {
          clearTimeout(this.timeout);
        }
        var value = e.target.value;
        if (value !== this.props.value) {
          this.props.onChange(value);
        }
        this.props.onEnter(value);
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      var value = e.target.value;
      this.setState({ value: value });
      if (this.timeout) {
        clearTimeout(this.timeout);
      }
      this.timeout = setTimeout(function () {
        this.props.onChange(value);
      }.bind(this), this.props.delay);
    }
  }, {
    key: 'render',
    value: function render() {
      var extendProps = (0, _omit2.default)(this.props, ['value', 'onKeyPress', 'onChange', 'delay']);
      return _react2.default.createElement('input', _extends({}, extendProps, {
        value: this.state.value,
        onKeyPress: this.handlePress.bind(this),
        onChange: this.handleChange.bind(this) }));
    }
  }]);

  return InputSelect;
}(_react2.default.Component);

InputSelect.propTypes = {
  value: _react.PropTypes.string,
  onChange: _react.PropTypes.func,
  onEnter: _react.PropTypes.func,
  delay: _react.PropTypes.number
};

InputSelect.defaultProps = {
  delay: 300
};

exports.default = InputSelect;
module.exports = exports['default'];